package wlstest.functional.jms.wlsra.common.apps.mdbs.jboss;

import javax.annotation.Resource;
import javax.ejb.CreateException;
import javax.ejb.MessageDrivenBean;
import javax.ejb.MessageDrivenContext;
import javax.jms.ConnectionFactory;
import javax.jms.DeliveryMode;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.Queue;
import javax.jms.QueueConnection;
import javax.jms.QueueConnectionFactory;
import javax.jms.QueueSession;
import javax.jms.QueueSender;
import javax.jms.Session;
import javax.jms.StreamMessage;
import javax.jms.TextMessage;
import javax.naming.NamingException;
import javax.naming.InitialContext;

//import weblogic.transaction.Transaction;
import javax.transaction.Transaction;
import javax.transaction.TransactionManager;

//import weblogic.transaction.TransactionHelper;
import org.jboss.ejb3.annotation.ResourceAdapter;
import javax.annotation.*;
import javax.ejb.*;
/*
 * 
 */
@MessageDriven(name = "MultiTranMDB", activationConfig = {
		@ActivationConfigProperty(propertyName = "ConnectionFactory", propertyValue = "java:jboss/wljmsra/xcf"),
		@ActivationConfigProperty(propertyName = "DestinationType", propertyValue = "javax.jms.Queue"),
		@ActivationConfigProperty(propertyName = "Destination", propertyValue = "java:jboss/wljmsra/mqueue"),
		@ActivationConfigProperty(propertyName="transactionTimeout", propertyValue="120"), })
@TransactionManagement(TransactionManagementType.CONTAINER)
@TransactionAttribute(TransactionAttributeType.REQUIRED)
@ResourceAdapter(value = "wl-jms-ra.rar")
public class MultiTranMDB implements MessageDrivenBean, MessageListener {
  //private final static String JMS_FACTORY = "java:comp/env/jms/QueueCFFactory";
	
	@Resource(mappedName = "java:jboss/wljmsra/qcf")
	private QueueConnectionFactory qcf;

//  private static String RA_SERVER_CTX = "java:comp/env/jmsraClusterCtx";  
  
  //private static String WL_XA_CF = "java:comp/env/jms/XACFFactory";
	
	@Resource(mappedName = "java:jboss/wljmsra/wxcf")
	private ConnectionFactory wxcf;	
  
  private MessageDrivenContext context;

  private int messagesInTransaction;

  private Transaction currentTransaction;

  private Transaction previousTransaction;

  private boolean replyCode = true;
  
  //private TransactionHelper txHelper;
  
  private TransactionManager txManager;

  //private Context raContext;
  public MultiTranMDB() {
    System.out.println("MultiTranMDB constructed");
  }

  public void ejbRemove() {
    System.out.println("MultiTranMDB removed");
    context = null;
  }

  public void setMessageDrivenContext(MessageDrivenContext context) {
    this.context = context;
  }

  public void ejbCreate() throws CreateException {
	//txHelper = TransactionHelper.getTransactionHelper();
	//raContext = (Context) context.lookup(RA_SERVER_CTX);
    System.out.println("MultiTranMDB created");
  }

  private void doReply(Queue replyQueue, boolean localReplyCode) {
    InitialContext context = null;
    QueueConnectionFactory theConnectionFactory;
    QueueConnection theConnection = null;
    QueueSession theSession = null;
    QueueSender theSender = null;

    try {

      try {
        context = new InitialContext();
        //theConnectionFactory = (QueueConnectionFactory) context.lookup(JMS_FACTORY);
        theConnectionFactory = qcf;
      } catch (NamingException ne) {
        ne.printStackTrace();
        System.out
            .println("ERROR: Could not get JMS connection factory: " + ne);
        return;
      }

      try {
        theConnection = theConnectionFactory.createQueueConnection();
        theSession = theConnection.createQueueSession(false,
            Session.AUTO_ACKNOWLEDGE);
        theSender = theSession.createSender(replyQueue);

        StreamMessage sm = theSession.createStreamMessage();
        sm.writeBoolean(localReplyCode);

        theSender.send(sm, DeliveryMode.PERSISTENT, 4, 60 * 60 * 1000);
      } catch (JMSException jmse) {
        jmse.printStackTrace();
        System.out.println("ERROR: Could not send reply: " + jmse);
        return;
      }

    } finally {
      try {
        if (theSender != null) {
          theSender.close();
          theSender = null;
        }
        if (theSession != null) {
          theSession.close();
          theSession = null;
        }
        if (theConnection != null) {
          theConnection.close();
          theConnection = null;
        }
      } catch (JMSException jmse) {
        jmse.printStackTrace();
        System.out.println("ERROR: Could not close jms artifact: " + jmse);
      }
    }

    return;
  }

  /*
   * 
   * - 5 msgs in tran (max-messages-in-transaction) - if one message in a batch
   * encounters error that causes rollback of entire batch and the whole batch
   * is redelivered and processed individually. - verify, upon redelivery of
   * batch, the transaction in which each message is processed is totally
   * different from each others. - (mark all messages in such batch with
   * "SUPPOSEDTOBEREDELIVERED" and one message with "ROLLBACK" that triggers
   * reprocessing) - 1 message in the batch (marked for ROLLBACK) - 3 messages
   * in the batch (last one marked for ROLLBACK) - 5 messages in the batch
   * (middle one marked for ROLLBACK) - 5 messages in the batch (last one marked
   * for ROLLBACK)
   */
  public boolean doReplyForTxBatchRetryTest(Message m, String txid) {
    InitialContext context4batchtest = null;
    javax.jms.ConnectionFactory theCF4batchtest;
    javax.jms.Connection theConn4batchtest = null;
    javax.jms.Session theSession4batchtest = null;
    weblogic.jms.extensions.WLMessageProducer theSender4batchtest = null;

    System.out.println("MultiTranMDB: RRR: in doReplyForTxBatchRetryTest..#1");
    try {
      try {
        context4batchtest = new InitialContext();
        //theCF4batchtest = (javax.jms.ConnectionFactory) context4batchtest
        //    .lookup(WL_XA_CF);
        theCF4batchtest = wxcf;
      } catch (NamingException ne) {
        ne.printStackTrace();
        System.out
            .println("ERROR: Could not get JMS connection factory: " + ne);
        return false;
      }

      try {
        theConn4batchtest = theCF4batchtest.createConnection();
        theSession4batchtest = theConn4batchtest.createSession(false,
            Session.AUTO_ACKNOWLEDGE);
        theSender4batchtest = (weblogic.jms.extensions.WLMessageProducer) theSession4batchtest
            .createProducer((Queue) m.getJMSReplyTo());
        theSender4batchtest.setUnitOfOrder(m
            .getStringProperty("JMS_BEA_UnitOfOrder"));

        StreamMessage sm = theSession4batchtest.createStreamMessage();
        sm.setStringProperty("TXID", txid);
        sm.setStringProperty("OMSGID", m.getJMSMessageID());
        // sm.setStringProperty("TESTID", m.getStringProperty("TESTID"));

        System.out
            .println("MultiTranMDB: RRR: in doReplyForTxBatchRetryTest..#2");
        theSender4batchtest.send(sm, DeliveryMode.PERSISTENT, 4, 0);
      } catch (JMSException jmse) {
        System.out.println("ERROR: Could not send reply: " + jmse);
        jmse.printStackTrace();
        return false;
      }
    } // outer try
    finally {
      try {
        if (theSender4batchtest != null) {
          theSender4batchtest.close();
          theSender4batchtest = null;
        }
        if (theSession4batchtest != null) {
          theSession4batchtest.close();
          theSession4batchtest = null;
        }
        if (theConn4batchtest != null) {
          theConn4batchtest.close();
          theConn4batchtest = null;
        }
      } catch (JMSException jmse) {
        jmse.printStackTrace();
        System.out.println("ERROR: Could not close jms artifact: " + jmse);
      }
    } // finally block

    return true;
  } // doReplyForTxBatchRetryTest

  // #########################################################################33333
  public void rollbackIfMarkedAndNotRedelivered(Message msg) {
    try {
      String text = msg.getJMSMessageID();
      if (msg.propertyExists("ROLLBACK") && !msg.getJMSRedelivered()) { // rollback
                                                                        // once
        System.out
            .println("MultiTranMDB: RRR: message marked for ROLLBACK .....");
        throw new RuntimeException(
            "Throwing RTE in order to roll back and other msgs in the batch retried individually..["
                + text + "]");
      } else if (msg.propertyExists("ROLLBACK") && msg.getJMSRedelivered()) { // redelivered
        System.out
            .println("ERROR: Got a reply queue but we were supposed to have more msgs");
      }
      /*
       * else if ( (!msg.propertyExists("ROLLBACK")) && msg.getJMSRedelivered()
       * ) System.out.println("Message unexpectedly redelivered ..["+text+"]");
       */
    } catch (JMSException jmse) {
      jmse.printStackTrace();
      System.out.println("ERROR: Could not get property .... : " + jmse);
    }
  } // rollbackIfMarkedAndNotRedelivered

  // #########################################################################33333
  public boolean ifMessageBelongs2TxBatchRetryTest(Message msg) {
    try {
      return msg.propertyExists("Message4TxBatchRetryTest");
    } catch (JMSException jmse) {
      return false;
    }
  }

  // #########################################################################33333
  public boolean processMessageForTxBatchRetryTest(Message msg,
      String strthisTransaction) throws JMSException {
    // System.out.println("MultiTranMDB: RRR: in processMessageForTxBatchRetryTest.....");
    rollbackIfMarkedAndNotRedelivered(msg);
    return doReplyForTxBatchRetryTest(msg, strthisTransaction);
  }

  // #########################################################################33333
  public void onMessage(Message msg) {
    //Transaction thisTransaction = txHelper.getTransaction();
	  
	Transaction thisTransaction = null; 
	try {
		InitialContext context = new InitialContext();
		txManager = (TransactionManager)context.lookup("java:/TransactionManager");
		thisTransaction = txManager.getTransaction();
    } catch (Exception ne) {
        ne.printStackTrace();
        System.out
            .println("ERROR: Could not get Transaction Manager: " + ne);
    }	  
    boolean localReplyCode = true;

    // System.out.println("RR:MultiTranMDB:onMessage: ttx: "+
    // thisTransaction.toString().substring(0,
    // thisTransaction.toString().indexOf(")")+1)+"; MsgID="+msg.getJMSMessageID());
    if (ifMessageBelongs2TxBatchRetryTest(msg)) {
      try {
        if (msg instanceof StreamMessage) {
          StreamMessage smsg = (StreamMessage) msg;
          long stime = smsg.readLong();
          try {
            if (stime > 0)
              Thread.sleep(stime);
          } catch (InterruptedException ie) {
          }
        }
        processMessageForTxBatchRetryTest(msg, thisTransaction.toString());
        return;
      } catch (JMSException jmse) {
        jmse.printStackTrace();
        System.out.println("ERROR: MulitTranMDB got an exception : " + jmse);
        return;
      }
    } else
      ; // if not then continue below.

    if (msg instanceof StreamMessage) {
      StreamMessage smsg = (StreamMessage) msg;
      long sleepTime = 1000;

      if (currentTransaction != null) {
        System.out
            .println("ERROR: MultiTranMDB Got a start message but were expecting to be in transaction "
                + currentTransaction);
        System.out
            .println("ERROR: MultiTranMDB We are currently in transaction "
                + thisTransaction);
        localReplyCode = false;
        currentTransaction = null;
        messagesInTransaction = 0;
      }

      if (previousTransaction != null) {
        // Make sure that this actually a different transaction
        if (previousTransaction.equals(thisTransaction)) {
          System.out
              .println("ERROR: MultiTranMDB This should be a new transaction");
          localReplyCode = false;
        }
      }

      try {
        sleepTime = smsg.readLong();
        messagesInTransaction = smsg.readInt();
      } catch (JMSException jmse) {
        jmse.printStackTrace();
        System.out
            .println("ERROR: MulitTranMDB got an exception reading a long from a stream message: "
                + jmse);
        return;
      }

      if (sleepTime > 0) {
        try {
          Thread.sleep(sleepTime);
        } catch (InterruptedException ie) {
          // Ignore
        }
      }

      currentTransaction = thisTransaction;
      replyCode = localReplyCode;
    } else if (currentTransaction == null) {
      System.out
          .println("ERROR: MultiTranMDB Not in current transaction but got non-stream message");
      replyCode = false;
    }

    if (replyCode == true) {
      if (messagesInTransaction > 0) {
        if (!currentTransaction.equals(thisTransaction)) {
          System.out.println("ERROR: MultiTranMDB messagesInTransaction="
              + messagesInTransaction);
          System.out.println("ERROR: MultiTranMDB currentTransaction="
              + currentTransaction);
          System.out.println("ERROR: MultiTranMDB thisTransaction="
              + thisTransaction);
          replyCode = false;
          localReplyCode = false;
          currentTransaction = null;
          messagesInTransaction = 0;
        } else {
          messagesInTransaction--;
        }
      }
    } else {
      localReplyCode = false;
    }

    Queue replyQueue;

    try {
      if ((replyQueue = (Queue) msg.getJMSReplyTo()) != null) {
        if ((localReplyCode == true) && (messagesInTransaction > 0)) {
          System.out
              .println("ERROR: Got a reply queue but we were supposed to have more msgs");
          System.out.println("ERROR: MultiTranMDB messagesInTransaction="
              + messagesInTransaction);
          System.out.println("ERROR: MultiTranMDB currentTransaction="
              + currentTransaction);
          System.out.println("ERROR: MultiTranMDB thisTransaction="
              + thisTransaction);
          localReplyCode = false;
        }
        doReply(replyQueue, localReplyCode);

        replyCode = true;
        messagesInTransaction = 0;
        previousTransaction = currentTransaction;
        currentTransaction = null;
      }
    } catch (JMSException jmse) {
      jmse.printStackTrace();
      System.out.println("ERROR: Could not get replyTo queue from message: "
          + jmse);
    }

    return;
  }
}
